## openjdk-11 11.0.12+7

=== debian/changelog ===
openjdk-11 (11.0.12+7-2) unstable; urgency=high

  * OpenJDK 11.0.12+7 build (release).
  * Security fixes:
    - JDK-8256157: Improve bytecode assembly.
    - JDK-8256491: Better HTTP transport.
    - JDK-8258432, CVE-2021-2341: Improve file transfers.
    - JDK-8260453: Improve Font Bounding.
    - JDK-8260960: Signs of jarsigner signing.
    - JDK-8260967, CVE-2021-2369: Better jar file validation.
    - JDK-8262380: Enhance XML processing passes.
    - JDK-8262403: Enhanced data transfer.
    - JDK-8262410: Enhanced rules for zones.
    - JDK-8262477: Enhance String Conclusions.
    - JDK-8262967: Improve Zip file support.
    - JDK-8264066, CVE-2021-2388: Enhance compiler validation.
    - JDK-8264079: Improve abstractions.
    - JDK-8264460: Improve NTLM support.
  * Encode the early-access status into the package version. LP: #1934895.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 Jul 2021 09:03:54 +0200

openjdk-11 (11.0.12+6-1) unstable; urgency=medium

  * OpenJDK 11.0.12+6 build (early access).

 -- Matthias Klose <doko@ubuntu.com>  Wed, 07 Jul 2021 12:00:44 +0200

openjdk-11 (11.0.12+4-1) unstable; urgency=medium

  * OpenJDK 11.0.12+4 build (early access).
  * Don't apply the m68k-support patch, needs an update.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 27 May 2021 11:37:31 +0200

openjdk-11 (11.0.11+9-1) unstable; urgency=high

  * OpenJDK 11.0.11+9 build (release).
  * Security fixes:
    - JDK-8244473: Contextualize registration for JNDI.
    - JDK-8244543: Enhanced handling of abstract classes.
    - JDK-8259633: compiler/graalunit/CoreTest.java fails with NPE
      after JDK-8244543.
    - JDK-8250568: Less ambiguous processing (CVE-2021-2161).
    - JDK-8253799: Make lists of normal filenames.
    - JDK-8261183: Follow on to Make lists of normal filenames.
    - JDK-8249906: Enhance opening JARs (CVE-2021-2163).
    - JDK-8258247: Couple of issues in fix for JDK-8249906.
    - JDK-8259428: AlgorithmId.getEncodedParams() should return copy.
    - JDK-8257001: Improve HTTP client support.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 Apr 2021 20:21:22 +0200

openjdk-11 (11.0.11+8-1) unstable; urgency=medium

  * OpenJDK 11.0.11+8 build (early access).
  * Set DEB_BUILD_MAINT_OPTIONS = optimize=-lto, not yet ready. Looks
    like 16 and 17 are buildable with lto.
  * Remove dangling jfr alternative on upgrades if no jdk is installed (Andreas
    Beckmann). Closes: #985060.
  * Use mktemp instead of tempfile in maintainer scripts (Andreas Beckmann).
  * Backport fix for JDK-8262085, hovering Metal HTML Tooltips in different
    windows cause IllegalArgExc on Linux. Closes: #967049.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 01 Apr 2021 12:24:55 +0200

openjdk-11 (11.0.11+7-1) unstable; urgency=medium

  * OpenJDK 11.0.11+7 build (early access).
  * Simplify compiler selection for backports.
  * Don't use the triplet-prefixed binutils tools for backports.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 18 Mar 2021 09:49:54 +0100

openjdk-11 (11.0.11+4-1) unstable; urgency=medium

  * OpenJDK 11.0.11+4 build (early access).
  * reproducible-build-jmod.diff: Fall back to the unpatched behavior
    for backports.
  * Only build with system harfbuzz for recent releases.
  * Configure --with-copyright-year. Closes: #956154.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 25 Feb 2021 11:54:00 +0100

openjdk-11 (11.0.11+3-3) experimental; urgency=medium

  * Fix the build logic, jaotc and jhsdb tools not available on all archs.
  * Ship the jfc files used by jfr.
  * Move libawt_xawt.so, libjawt.so into the jre package. Closes: #908058.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 20 Feb 2021 09:12:35 +0100

openjdk-11 (11.0.11+3-2) experimental; urgency=medium

  * OpenJDK 11.0.11+3 build (early access).
  * Use debugedit to generate unique build-id's and remove the openjdk-N-dbg
    file conflicts. Closes: #919671.
  * Remove KFreeBSD build support and patches, not updated since OpenJDK 8.
  * Backport JDK-8222825. Closes: #960153.
  * Build with Rules-Requires-Root: no.
  * Move the jfr binary from -jre-headless to -jdk-headless. Development tool.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Feb 2021 13:54:09 +0100

openjdk-11 (11.0.10+9-1) unstable; urgency=high

  * OpenJDK 11.0.10+9 build (release).
  * Security fixes:
    - JDK-8247619: Improve Direct Buffering of Characters.
  * Other changes:
    See https://mail.openjdk.java.net/pipermail/jdk-updates-dev/2021-January/004689.html
  * Update copyright years.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Jan 2021 10:42:16 +0100

openjdk-11 (11.0.10+8-1) unstable; urgency=medium

  * OpenJDK 11.0.10+8 build (early access).
  * Build with system harfbuzz.
  * Refresh patches.
  * Don't run the autopkg tests. There's no value running all the internal
    tests as an autopkg test, when these are already run during the build.
  * Update VCS attributes.
  * Bump standards version.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 30 Dec 2020 13:50:32 +0100

=== debian/control ===
Source: openjdk-11
Section: java
Priority: optional
Maintainer: OpenJDK Team <openjdk-11@packages.debian.org>
Uploaders: Matthias Klose <doko@ubuntu.com>
Build-Depends: debhelper (>= 11),
  m4, lsb-release, zip, unzip,
  sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
  time, strip-nondeterminism, debugedit (>= 4.16),
  jtreg (>= 4.2-b13-0~) <!nocheck>, testng <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>,
  autoconf, automake, autotools-dev, ant, ant-optional,
  g++-10 <!cross>,
  openjdk-11-jdk-headless:native | openjdk-10-jdk-headless:native,
  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libgtk2.0-0 | libgtk-3-0, libharfbuzz-dev,
  libffi-dev,
  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, 
  libnss3-dev (>= 2:3.17.1),
  openjdk-11-jdk-headless <cross>,
Build-Depends-Indep: graphviz, pandoc,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://openjdk.java.net/
Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk/tree/openjdk-11
Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git -b openjdk-11

Package: openjdk-11-jdk-headless
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-11-jre-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Suggests: openjdk-11-demo, openjdk-11-source
Provides: java-sdk-headless, java2-sdk-headless,
  java5-sdk-headless, java6-sdk-headless,
  java7-sdk-headless, java8-sdk-headless,
  java9-sdk-headless, java10-sdk-headless,
  java11-sdk-headless, java-compiler
Breaks: openjdk-11-jre-headless (<< 11.0.11+3-2~)
Replaces: openjdk-11-jre-headless (<< 11.0.11+3-2~)
Description: OpenJDK Development Kit (JDK) (headless)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-11-jre-headless
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: ${jredefault:Depends}, ${cacert:Depends},
  ${jcommon:Depends}, ${dlopenhl:Depends},
  ${mountpoint:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenhl:Recommends}
Suggests: libnss-mdns,
  fonts-dejavu-extra,
  fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
Provides: java-runtime-headless, java2-runtime-headless,
  java5-runtime-headless, java6-runtime-headless,
  java7-runtime-headless, java8-runtime-headless,
  java9-runtime-headless, java10-runtime-headless,
  java11-runtime-headless,
  ${defaultvm:Provides}, ${jvm:Provides}
Breaks: ${jrehl:Breaks}
Conflicts: oracle-java11-installer, openjdk-11-jdk-headless (<< 11~18-2)
Replaces: openjdk-11-jdk-headless (<< 11~18-2)
Description: OpenJDK Java runtime, using ${vm:Name} (headless)
 Minimal Java runtime - needed for executing non GUI Java programs,
 using ${vm:Name}.

Package: openjdk-11-jdk
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-11-jre (= ${binary:Version}),
  openjdk-11-jdk-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libxt-dev
Suggests: openjdk-11-demo, openjdk-11-source, visualvm
Provides: java-sdk, java2-sdk, java5-sdk, java6-sdk,
  java7-sdk, java8-sdk, java9-sdk, java10-sdk, java11-sdk,
  java-compiler
Conflicts: openjdk-11-jre-headless (<< 11~19-2)
Replaces: openjdk-11-jre-headless (<< 11~19-2)
Description: OpenJDK Development Kit (JDK)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-11-jre
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-11-jre-headless (= ${binary:Version}),
  ${xandsound:Depends}, ${dlopenjre:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenjre:Recommends}, ${bridge:Recommends}, fonts-dejavu-extra
Provides: java-runtime, java2-runtime,
  java5-runtime, java6-runtime,
  java7-runtime, java8-runtime,
  java9-runtime, java10-runtime,
  java11-runtime,
Breaks: openjdk-11-jre-headless (<< 11.0.11+3-3~)
Replaces: openjdk-11-jre-headless (<< 11.0.11+3-3~)
Description: OpenJDK Java runtime, using ${vm:Name}
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using ${vm:Name}.

Package: openjdk-11-demo
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-11-jre (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Description: Java runtime based on OpenJDK (demos and examples)
 OpenJDK Java runtime

Package: openjdk-11-source
Architecture: all
Multi-Arch: foreign
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-11-jdk (>= ${source:Version}),
  ${misc:Depends}
Description: OpenJDK Development Kit (JDK) source files
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the Java programming language source files
 (src.zip) for all classes that make up the Java core API.

Package: openjdk-11-doc
Section: doc
Pre-Depends: ${dpkg:Depends}
Architecture: all
Multi-Arch: foreign
Priority: optional
Depends: ${misc:Depends}
Suggests: openjdk-11-jdk
Description: OpenJDK Development Kit (JDK) documentation
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the API documentation.

Package: openjdk-11-dbg
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Priority: optional
Section: debug
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-11-jre-headless (= ${binary:Version}),
   ${misc:Depends}
Recommends: openjdk-11-jre (= ${binary:Version})
Suggests: openjdk-11-jdk (= ${binary:Version})
Conflicts: ${dbg:Conflicts}
Description: Java runtime based on OpenJDK (debugging symbols)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the debugging symbols.

Package: openjdk-11-jre-zero
Architecture: amd64 i386 arm64 ppc64 ppc64el s390x
Multi-Arch: same
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-11-jre-headless (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: ${zerovm:Provides}
Description: Alternative JVM for OpenJDK, using Zero
 The package provides an alternative runtime using the Zero VM. Built on
 architectures in addition to the Hotspot VM as a debugging aid for those
 architectures which don't have a Hotspot VM.
 .
 The VM is started with the option `-zero'. See the README.Debian for details.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

unexport LANG LC_ALL

dh_version := $(shell dpkg-query -f '$${Version}\n' -W debhelper | sed -n 's/^\(.\).*/\1/p')

# using brace expansion and substring replacements (${var:0:2}).
SHELL = /bin/bash

# use gnu time in verbose mode if available, otherwise default to the shell builtin
ifneq (,$(wildcard /usr/bin/time))
  TIME = /usr/bin/time -v
else
  TIME = time
endif

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_HOST_ARCH_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_CPU)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

PATH := $(CURDIR)/bin:$(PATH)
export PATH

CHANGELOG_VARS := $(shell dpkg-parsechangelog | sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)
PKGYEAR := $(shell echo $(call vafilt,$(CHANGELOG_VARS),Timestamp) | date --utc +%Y)

distribution := $(shell lsb_release --id --short)
distrel := $(shell lsb_release --codename --short)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)
ifeq ($(distrel),n/a)
  distrel := sid
endif

ifneq (,$(filter $(distrel),precise))
  OBJCOPY := objcopy
  STRIP := strip
else
  OBJCOPY := $(DEB_HOST_GNU_TYPE)-objcopy
  STRIP := $(DEB_HOST_GNU_TYPE)-strip
endif

multiarch_dir = /$(DEB_HOST_MULTIARCH)

hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el sparc64 s390x
jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc powerpcspe ppc64 sh4 x32
jtreg_archs	+= armel mipsel mips64el

# FIXME: use bootcycle builds for zero archs?
bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
zbootcycle_build =
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
  bootcycle_build =
  zbootcycle_build =
endif
ifneq (,$(filter nobootcycle, $(DEB_BUILD_OPTIONS)))
  bootcycle_build =
  zbootcycle_build =
endif

ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie))
  is_default = no
else
  is_default = yes
endif

is_upstream_release = yes

srcdir		= .
builddir	= build
zbuilddir	= build-zero

VENDOR		= openjdk
Vendor		= OpenJDK
TOP		= usr/lib/jvm
origin		= openjdk
basename	= openjdk-$(shortver)
ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
  priority	= $(if $(filter yes, $(is_default)),1111,1109)
  vm_name	= Hotspot JIT
else
  priority	= $(if $(filter yes, $(is_default)),1104,1103)
  vm_name	= Hotspot Zero
endif
jvmver		= 1.11.0
shortver	= 11
v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//')
v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')
# FIXME. currently v_upstream like 11~4
v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
#v_upbase	:= $(word 1, $(subst ~, , $(v_upstream)))
#v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
# that should be the package version ...

ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
endif
#ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
#  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
#endif

ifneq (,$(DEB_HOST_MULTIARCH))
  jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
  jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
  commonbasedir	= $(basedir)
  etcdir	= etc/java-$(shortver)-$(origin)
else
  jdirname	= java-$(shortver)-$(origin)
  jdiralias	= java-$(jvmver)-$(origin)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
  etcdir	= etc/$(jdirname)
endif
security	= $(etcdir)/security
ifeq ($(bootcycle_build),yes)
  sdkimg	= bootcycle-build/images/jdk
  build_target	= bootcycle-images test-image
else
  sdkimg	= images/jdk
  build_target	= images test-image
endif
ifeq ($(zbootcycle_build),yes)
  zsdkimg	= bootcycle-build/images/jdk
  zbuild_target	= bootcycle-images test-image
else
  zsdkimg	= images/jdk
  zbuild_target	= images test-image
endif

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
COMMA=,
SPACE = $(EMPTY) $(EMPTY)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
# see Debian #920161
ifneq (,$(filter $(DEB_HOST_ARCH), alpha))
  with_check = disabled running check on $(DEB_HOST_ARCH)
endif
# no jtreg backport yet
ifneq (,$(filter $(distrel), precise trusty xenial))
  with_check = disabled for $(distrel)
endif

with_docs = $(if $(findstring nodoc, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(distrel), precise trusty))
  with_docs =
endif
# with_check = disabled for this upload

with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)

arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc powerpcspe=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32

jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
ifeq ($(DEB_HOST_ARCH),x32)
  jvmarch := x32
endif

default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)

any_archs = alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

altzero_archs = $(hotspot_archs)
ifneq (,$(filter $(distrel),trusty))
  altzero_archs := $(filter-out arm64, $(altzero_archs))
endif
# ftbfs in 11.0.5+bx, and 13+17
altzero_archs := $(filter-out armhf, $(altzero_archs))

# FIXME: Zero currently FTBFS on sparc64 with gcc-9
altzero_archs := $(filter-out sparc64, $(altzero_archs))

ifneq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS)))
  altzero_archs =
else ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
  alternate_vms += zero
  zero_dir = zero
endif

# needed for the jexec build
export DEBIAN_JDK_BASE_DIR := /$(basedir)

BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
			/usr/lib/jvm/java-10-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
			/usr/lib/jvm/java-11-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
		))))

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
else
  BUILDJDK_HOME = $(BOOTJDK_HOME)
endif

# for Hotspot: hotspot/make/linux/makefiles/vm.make
# Don't overwrite Hotspot opt level :
# -O3 is already default option for hotspot

# FIXME: ftbfs with -Werror=format-security
dpkg_buildflags_hs = \
	DEB_BUILD_MAINT_OPTIONS="optimize=-lto" \
	DEB_CFLAGS_MAINT_STRIP="-O2 -Werror=format-security" \
	DEB_CXXFLAGS_MAINT_STRIP="-O2 -Werror=format-security" \
	DEB_CFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations" \
	DEB_CXXFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations$(if $(filter $(DEB_HOST_ARCH), armel armhf), -fpermissive)"
# jdk/make/CompileDemos.gmk (SetupJVMTIDemo) doesn't like commas in flags
dpkg_buildflags_hs += \
	DEB_LDFLAGS_MAINT_STRIP="-Wl,-z,relro -Wl,-Bsymbolic-functions" \
	DEB_LDFLAGS_MAINT_APPEND="-Xlinker -z -Xlinker relro -Xlinker -Bsymbolic-functions"
dpkg_buildflags_hs += dpkg-buildflags

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-11-jre-headless
Restrictions: superficial

Test-Command: javac --version
Depends: openjdk-11-jdk-headless
Restrictions: superficial

#Tests: hotspot, jaxp, langtools
#Depends: @, default-jre-headless, jtreg:native (>= 4.2-b13-0~), testng:native, build-essential
#Restrictions: allow-stderr, skippable, flaky

#Tests: jdk
#Depends: @, default-jre-headless, jtreg:native (>= 4.2-b13-0~), testng:native, build-essential, xfwm4:native, xvfb, dbus-x11
#Restrictions: allow-stderr, skippable, flaky

## openjdk-11 11.0.14+9

=== debian/changelog ===
openjdk-11 (11.0.14+9-1~deb11u1) bullseye-security; urgency=medium

  * Rebuild for bullseye

 -- Moritz Muehlenhoff <jmm@debian.org>  Fri, 21 Jan 2022 00:04:26 +0000

openjdk-11 (11.0.14+9-1) unstable; urgency=high

  * OpenJDK 11.0.14+9 build (release).

 -- Matthias Klose <doko@debian.org>  Wed, 19 Jan 2022 11:05:38 +0100

openjdk-11 (11.0.13+8-1) unstable; urgency=medium

  * OpenJDK 11.0.13+8 build (release).
  * Security fixes
    - JDK-8163326, CVE-2021-35550: Update the default enabled cipher suites preference
    - JDK-8254967, CVE-2021-35565: com.sun.net.HttpsServer spins on TLS session close
    - JDK-8263314: Enhance XML Dsig modes
    - JDK-8265167, CVE-2021-35556: Richer Text Editors
    - JDK-8265574: Improve handling of sheets
    - JDK-8265580, CVE-2021-35559: Enhanced style for RTF kit
    - JDK-8265776: Improve Stream handling for SSL
    - JDK-8266097, CVE-2021-35561: Better hashing support
    - JDK-8266103: Better specified spec values
    - JDK-8266109: More Resilient Classloading
    - JDK-8266115: More Manifest Jar Loading
    - JDK-8266137, CVE-2021-35564: Improve Keystore integrity
    - JDK-8266689, CVE-2021-35567: More Constrained Delegation
    - JDK-8267086: ArrayIndexOutOfBoundsException in java.security.KeyFactory.generatePublic
    - JDK-8267712: Better LDAP reference processing
    - JDK-8267729, CVE-2021-35578: Improve TLS client handshaking
    - JDK-8267735, CVE-2021-35586: Better BMP support
    - JDK-8268193: Improve requests of certificates
    - JDK-8268199: Correct certificate requests
    - JDK-8268205: Enhance DTLS client handshake
    - JDK-8268506: More Manifest Digests
    - JDK-8269618, CVE-2021-35603: Better session identification
    - JDK-8269624: Enhance method selection support
    - JDK-8270398: Enhance canonicalization
    - JDK-8270404: Better canonicalization
  * Remove patches applied upstream.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Oct 2021 11:01:48 +0200

## openjdk-11 11.0.15+10

=== debian/changelog ===
openjdk-11 (11.0.15+10-11.2.0.lnd.2) unstable; urgency=medium

  * apply default-jvm-cfg.diff

 -- Ao Qi <aoqi@loongson.cn>  Thu, 11 Aug 2022 15:31:40 +0800

openjdk-11 (11.0.15+10-11.2.0.lnd.1) unstable; urgency=medium

  * 版本升级，由11.0.13+8升级至11.0.14+9
  * 版本升级，由11.0.14+9升级至11.0.15+10
  * [LoongArch] C1和分层编译支持，优化性能
  * [LoongArch] C2向量指令优化
  * [LoongArch] 优化GC停顿时间
  * [LoongArch] CRC32 Intrinsics优化
  * [LoongArch] 使用向量指令优化Array Copy
  * 优化ArrayFill
  * [LoongArch] 优化连续的membar
  * [LoongArch] 优化ReverseByte相关操作
  * [LoongArch] string equals优化
  * [LoongArch] 优化StringCoding.hasNegatives
  * [LoongArch] 优化Math.copySign
  * [LoongArch] 优化itable Stub
  * [LoongArch] AllocatePrefetch相关参数调优
  * [LoongArch] InlineSmallCode调优，默认值设为2000
  * 修复Redefine Class可能导致的偶发崩溃
  * 修复jvmti相关的随机错误
  * 修复push2/pop2入栈和出栈顺序问题
  * 修复Early Return可能导致浮点值恢复错误问题
  * 修复ori2s立即数越界问题

 -- Ao Qi <aoqi@loongson.cn>  Mon, 1 Aug 2022 11:43:32 +0800

openjdk-11 (11.0.13+8-11.1.0.lnd.1) unstable; urgency=medium

  * The first Loongson platform GA version based on OpenJDK 11
  * Corresponding to the community version 11.0.13+8

 -- Ao Qi <aoqi@loongson.cn>  Wed, 16 Feb 2022 10:46:48 +0800

openjdk-11 (11.0.12+7-11.0.2138.lnd.1) unstable; urgency=medium

  * The first Loongson platform EA version based on OpenJDK 11
  * Corresponding to the community version 11.0.12+7

 -- Ao Qi <aoqi@loongson.cn>  Sat, 23 Oct 2021 11:14:35 +0800

openjdk-11 (11.0.11+9-2.ea.20210603.lnd.1) unstable; urgency=medium

  * release ea-20210603 (3371f0116e)

 -- aoqi <aoqi@loongson.cn>  Tue, 08 Jun 2021 17:20:59 +0800

openjdk-11 (11.0.11+9-2.ea.20210602.lnd.1) unstable; urgency=medium

  * LoongArch64 and MIPS64 2nd round build

 -- aoqi <aoqi@loongson.cn>  Wed, 02 Jun 2021 14:24:51 +0800

openjdk-11 (11.0.11+9-2.ea.20210601.lnd.1) unstable; urgency=medium

  * LoongArch64 and MIPS64 initial support

 -- aoqi <aoqi@loongson.cn>  Tue, 01 Jun 2021 10:46:50 +0800

openjdk-11 (11.0.11+9-1~deb10u1) buster-security; urgency=medium

  * Rebuild for buster

 -- Moritz Muehlenhoff <jmm@debian.org>  Wed, 21 Apr 2021 15:55:49 +0000

=== debian/control ===
--- 
+++ 
@@ -4,19 +4,19 @@
 Maintainer: OpenJDK Team <openjdk-11@packages.debian.org>
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: debhelper (>= 11),
-  m4, lsb-release, zip, unzip,
+  m4, lsb-release, zip, unzip, wget,
   sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
-  time, strip-nondeterminism, debugedit (>= 4.16),
-  jtreg (>= 4.2-b13-0~) <!nocheck>, testng <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>,
+  time,  
+  jtreg (>= 4.2-b13-0~) <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>,
   autoconf, automake, autotools-dev, ant, ant-optional,
-  g++-10 <!cross>,
+  g++-8 <!cross>,
   openjdk-11-jdk-headless:native | openjdk-10-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libgtk2.0-0 | libgtk-3-0, libharfbuzz-dev,
   libffi-dev,
   zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, 
   libnss3-dev (>= 2:3.17.1),
   openjdk-11-jdk-headless <cross>,
-Build-Depends-Indep: graphviz, pandoc,
+Build-Depends-Indep: graphviz,
 Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://openjdk.java.net/
@@ -24,7 +24,7 @@
 Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git -b openjdk-11
 
 Package: openjdk-11-jdk-headless
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-11-jre-headless (= ${binary:Version}),
@@ -42,7 +42,7 @@
  applets, and components using the Java programming language.
 
 Package: openjdk-11-jre-headless
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: ${jredefault:Depends}, ${cacert:Depends},
@@ -67,7 +67,7 @@
  using ${vm:Name}.
 
 Package: openjdk-11-jdk
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-11-jre (= ${binary:Version}),
@@ -85,7 +85,7 @@
  applets, and components using the Java programming language.
 
 Package: openjdk-11-jre
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-11-jre-headless (= ${binary:Version}),
@@ -104,7 +104,7 @@
  programs, using ${vm:Name}.
 
 Package: openjdk-11-demo
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Priority: optional
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-11-jre (= ${binary:Version}),
@@ -141,7 +141,7 @@
  This package contains the API documentation.
 
 Package: openjdk-11-dbg
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Priority: optional
 Section: debug

=== debian/rules ===
--- 
+++ 
@@ -55,9 +55,9 @@
 
 multiarch_dir = /$(DEB_HOST_MULTIARCH)
 
-hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el sparc64 s390x
+hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el sparc64 s390x loongarch64 mips64el
 jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc powerpcspe ppc64 sh4 x32
-jtreg_archs	+= armel mipsel mips64el
+jtreg_archs	+= armel mipsel mips64el loongarch64
 
 # FIXME: use bootcycle builds for zero archs?
 bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
@@ -97,9 +97,9 @@
 endif
 jvmver		= 1.11.0
 shortver	= 11
-v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//')
-v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
-v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')
+v_upstream	:= $(shell echo $(PKGVERSION) | sed 's/-[^-][^-]*$$//')
+v_pkgrel	:= $(shell echo $(PKGVERSION) | sed 's/^.*-//')
+v_opt_ls	:= $(shell echo $(PKGVERSION) | sed -r 's/^.*-//;s/\.lnd.+//;s/[0-9]\.ea\.//')
 # FIXME. currently v_upstream like 11~4
 v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
 v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
@@ -107,11 +107,11 @@
 #v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
 # that should be the package version ...
 
-ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
-  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
-endif
-#ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
-#  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
+ifneq ($(PKGVERSION),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
+  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(PKGVERSION))
+endif
+#ifneq ($(PKGVERSION),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
+#  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(PKGVERSION))
 #endif
 
 ifneq (,$(DEB_HOST_MULTIARCH))
@@ -166,10 +166,16 @@
   with_docs =
 endif
 # with_check = disabled for this upload
+ifneq (,$(filter $(DEB_HOST_ARCH), mips64el))
+with_check = disabled for this build
+endif
+#ifneq (,$(filter $(DEB_HOST_ARCH), loongarch64))
+#with_check = disabled for this build
+#endif
 
 with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)
 
-arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc powerpcspe=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32
+arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k loongarch64=loongarch64 mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc powerpcspe=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32
 
 jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
 			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
@@ -179,7 +185,7 @@
 
 default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)
 
-any_archs = alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+any_archs = alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 
 altzero_archs = $(hotspot_archs)
 ifneq (,$(filter $(distrel),trusty))
@@ -223,8 +229,3 @@
 	DEB_CXXFLAGS_MAINT_STRIP="-O2 -Werror=format-security" \
 	DEB_CFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations" \
 	DEB_CXXFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations$(if $(filter $(DEB_HOST_ARCH), armel armhf), -fpermissive)"
-# jdk/make/CompileDemos.gmk (SetupJVMTIDemo) doesn't like commas in flags
-dpkg_buildflags_hs += \
-	DEB_LDFLAGS_MAINT_STRIP="-Wl,-z,relro -Wl,-Bsymbolic-functions" \
-	DEB_LDFLAGS_MAINT_APPEND="-Xlinker -z -Xlinker relro -Xlinker -Bsymbolic-functions"
-dpkg_buildflags_hs += dpkg-buildflags

## openjdk-11 11.0.16%2B8

=== nss/lib/util/Makefile ===
#! gmake
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

#######################################################################
# (1) Include initial platform-independent assignments (MANDATORY).   #
#######################################################################

include manifest.mn

#######################################################################
# (2) Include "global" configuration information. (OPTIONAL)          #
#######################################################################

# include $(CORE_DEPTH)/coreconf/arch.mk

include $(CORE_DEPTH)/coreconf/config.mk

#######################################################################
# (3) Include "component" configuration information. (OPTIONAL)       #
#######################################################################



#######################################################################
# (4) Include "local" platform-dependent assignments (OPTIONAL).      #
#######################################################################

include config.mk

#######################################################################
# (5) Execute "global" rules. (OPTIONAL)                              #
#######################################################################

include $(CORE_DEPTH)/coreconf/rules.mk

#######################################################################
# (6) Execute "component" rules. (OPTIONAL)                           #
#######################################################################



#######################################################################
# (7) Execute "local" rules. (OPTIONAL).                              #
#######################################################################


export:: private_export

test: $(OBJDIR)/test_utf8

$(OBJDIR)/test_utf8: utf8.c
	@$(MAKE_OBJDIR)
	$(CCF) -o $(OBJDIR)/test_utf8 -DTEST_UTF8 utf8.c $(OS_LIBS)

## openjdk-11 11.0.16+8

=== debian/changelog ===
openjdk-11 (11.0.16+8-1~deb10u1) buster-security; urgency=medium

  * Rebuild for buster

 -- Moritz Muehlenhoff <jmm@debian.org>  Thu, 21 Jul 2022 19:08:53 +0200

openjdk-11 (11.0.16+8-1) unstable; urgency=high

  * OpenJDK 11.0.16+8 build (release).

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Jul 2022 10:54:16 +0200

openjdk-11 (11.0.15+10-1) unstable; urgency=high

  * OpenJDK 11.0.15+10 build (release).
  * Security fixes
    - JDK-8269938: Enhance XML processing passes redux.
    - JDK-8270504, CVE-2022-21426: Better XPath expression handling.
    - JDK-8272255: Completely handle MIDI files.
    - JDK-8272261: Improve JFR recording file processing.
    - JDK-8272594: Better record of recordings.
    - JDK-8274221: More definite BER encodings.
    - JDK-8275082, JDK-8278008, CVE-2022-21476: Update XML Security for Java
      to 2.3.0.
    - JDK-8275151, CVE-2022-21443: Improved Object Identification.
    - JDK-8277227: Better identification of OIDs.
    - JDK-8277672, CVE-2022-21434: Better invocation handler handling.
    - JDK-8278356: Improve file creation.
    - JDK-8278449: Improve keychain support.
    - JDK-8278798: Improve supported intrinsic.
    - JDK-8278805: Enhance BMP image loading.
    - JDK-8278972, CVE-2022-21496: Improve URL supports.
    - JDK-8281388: Change wrapping of EncryptedPrivateKeyInfo.
  * Refresh patches.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 02 May 2022 19:42:14 +0200

openjdk-11 (11.0.14.1+1-1) unstable; urgency=medium

  * OpenJDK 11.0.14.1+1 build (release).
    - Fix JDK-8218546. LP: #1966338.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 27 Mar 2022 11:16:07 +0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: OpenJDK Team <openjdk-11@packages.debian.org>
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: debhelper (>= 11),
-  m4, lsb-release, zip, unzip, wget,
+  m4, lsb-release, zip, unzip,
   sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
   time,  
-  jtreg (>= 4.2-b13-0~) <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>,
+  jtreg (>= 5.1-b1-0~) <!nocheck>, testng <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>,
   autoconf, automake, autotools-dev, ant, ant-optional,
   g++-8 <!cross>,
   openjdk-11-jdk-headless:native | openjdk-10-jdk-headless:native,
@@ -16,7 +16,7 @@
   zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, 
   libnss3-dev (>= 2:3.17.1),
   openjdk-11-jdk-headless <cross>,
-Build-Depends-Indep: graphviz,
+Build-Depends-Indep: graphviz, pandoc,
 Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://openjdk.java.net/
@@ -24,7 +24,7 @@
 Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git -b openjdk-11
 
 Package: openjdk-11-jdk-headless
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-11-jre-headless (= ${binary:Version}),
@@ -42,7 +42,7 @@
  applets, and components using the Java programming language.
 
 Package: openjdk-11-jre-headless
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: ${jredefault:Depends}, ${cacert:Depends},
@@ -67,7 +67,7 @@
  using ${vm:Name}.
 
 Package: openjdk-11-jdk
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-11-jre (= ${binary:Version}),
@@ -85,7 +85,7 @@
  applets, and components using the Java programming language.
 
 Package: openjdk-11-jre
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-11-jre-headless (= ${binary:Version}),
@@ -104,7 +104,7 @@
  programs, using ${vm:Name}.
 
 Package: openjdk-11-demo
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Priority: optional
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-11-jre (= ${binary:Version}),
@@ -141,7 +141,7 @@
  This package contains the API documentation.
 
 Package: openjdk-11-dbg
-Architecture: alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 Multi-Arch: same
 Priority: optional
 Section: debug

=== debian/rules ===
--- 
+++ 
@@ -55,9 +55,9 @@
 
 multiarch_dir = /$(DEB_HOST_MULTIARCH)
 
-hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el sparc64 s390x loongarch64 mips64el
+hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el sparc64 s390x
 jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc powerpcspe ppc64 sh4 x32
-jtreg_archs	+= armel mipsel mips64el loongarch64
+jtreg_archs	+= armel mipsel mips64el
 
 # FIXME: use bootcycle builds for zero archs?
 bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
@@ -97,9 +97,9 @@
 endif
 jvmver		= 1.11.0
 shortver	= 11
-v_upstream	:= $(shell echo $(PKGVERSION) | sed 's/-[^-][^-]*$$//')
-v_pkgrel	:= $(shell echo $(PKGVERSION) | sed 's/^.*-//')
-v_opt_ls	:= $(shell echo $(PKGVERSION) | sed -r 's/^.*-//;s/\.lnd.+//;s/[0-9]\.ea\.//')
+v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//')
+v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
+v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')
 # FIXME. currently v_upstream like 11~4
 v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
 v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
@@ -107,11 +107,11 @@
 #v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
 # that should be the package version ...
 
-ifneq ($(PKGVERSION),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
-  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(PKGVERSION))
-endif
-#ifneq ($(PKGVERSION),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
-#  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(PKGVERSION))
+ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
+  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
+endif
+#ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
+#  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
 #endif
 
 ifneq (,$(DEB_HOST_MULTIARCH))
@@ -166,16 +166,10 @@
   with_docs =
 endif
 # with_check = disabled for this upload
-ifneq (,$(filter $(DEB_HOST_ARCH), mips64el))
-with_check = disabled for this build
-endif
-#ifneq (,$(filter $(DEB_HOST_ARCH), loongarch64))
-#with_check = disabled for this build
-#endif
 
 with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)
 
-arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k loongarch64=loongarch64 mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc powerpcspe=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32
+arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc powerpcspe=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32
 
 jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
 			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
@@ -185,7 +179,7 @@
 
 default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)
 
-any_archs = alpha amd64 armel armhf arm64 i386 ia64 loongarch64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
+any_archs = alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
 
 altzero_archs = $(hotspot_archs)
 ifneq (,$(filter $(distrel),trusty))
@@ -229,3 +223,8 @@
 	DEB_CXXFLAGS_MAINT_STRIP="-O2 -Werror=format-security" \
 	DEB_CFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations" \
 	DEB_CXXFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations$(if $(filter $(DEB_HOST_ARCH), armel armhf), -fpermissive)"
+# jdk/make/CompileDemos.gmk (SetupJVMTIDemo) doesn't like commas in flags
+dpkg_buildflags_hs += \
+	DEB_LDFLAGS_MAINT_STRIP="-Wl,-z,relro -Wl,-Bsymbolic-functions" \
+	DEB_LDFLAGS_MAINT_APPEND="-Xlinker -z -Xlinker relro -Xlinker -Bsymbolic-functions"
+dpkg_buildflags_hs += dpkg-buildflags

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-11-jre-headless
Restrictions: superficial

Test-Command: javac --version
Depends: openjdk-11-jdk-headless
Restrictions: superficial

#Tests: hotspot, jaxp, langtools
#Depends: @, default-jre-headless, jtreg:native (>= 5.1-b1-0~), testng:native, build-essential
#Restrictions: allow-stderr, skippable, flaky

#Tests: jdk
#Depends: @, default-jre-headless, jtreg:native (>= 5.1-b1-0~), testng:native, build-essential, xfwm4:native, xvfb, dbus-x11
#Restrictions: allow-stderr, skippable, flaky
